// Code generated by sqlc. DO NOT EDIT.
// source: query.sql

package query

import (
	"context"
	"database/sql"
)

const addComment = `-- name: AddComment :exec

insert into comments (wine_id, content) values ($1, $2)
`

type AddCommentParams struct {
	WineID  int32
	Comment string
}

//--
//-- Comments
//--
func (q *Queries) AddComment(ctx context.Context, arg AddCommentParams) error {
	_, err := q.db.ExecContext(ctx, addComment, arg.WineID, arg.Comment)
	return err
}

const addMigration = `-- name: AddMigration :exec
insert into migrations (name) values ($1)
`

func (q *Queries) AddMigration(ctx context.Context, name string) error {
	_, err := q.db.ExecContext(ctx, addMigration, name)
	return err
}

const countMigrations = `-- name: CountMigrations :one
select count(*) from migrations where name = $1
`

func (q *Queries) CountMigrations(ctx context.Context, name string) (int64, error) {
	row := q.db.QueryRowContext(ctx, countMigrations, name)
	var count int64
	err := row.Scan(&count)
	return count, err
}

const countUsers = `-- name: CountUsers :one
select count(*) from users
`

func (q *Queries) CountUsers(ctx context.Context) (int64, error) {
	row := q.db.QueryRowContext(ctx, countUsers)
	var count int64
	err := row.Scan(&count)
	return count, err
}

const deleteComment = `-- name: DeleteComment :exec
delete from comments where comment_id = $1
`

func (q *Queries) DeleteComment(ctx context.Context, commentID int32) error {
	_, err := q.db.ExecContext(ctx, deleteComment, commentID)
	return err
}

const deleteSession = `-- name: DeleteSession :exec
delete from sessions where token = $1
`

func (q *Queries) DeleteSession(ctx context.Context, token string) error {
	_, err := q.db.ExecContext(ctx, deleteSession, token)
	return err
}

const deleteUser = `-- name: DeleteUser :exec
delete from users where name = $1
`

func (q *Queries) DeleteUser(ctx context.Context, name string) error {
	_, err := q.db.ExecContext(ctx, deleteUser, name)
	return err
}

const deleteWine = `-- name: DeleteWine :exec
delete from wines where wine_id = $1
`

func (q *Queries) DeleteWine(ctx context.Context, wineID int32) error {
	_, err := q.db.ExecContext(ctx, deleteWine, wineID)
	return err
}

const getAuthData = `-- name: GetAuthData :one
select userID, password from users where name = $1
`

type GetAuthDataRow struct {
	UserID   int32
	Password string
}

func (q *Queries) GetAuthData(ctx context.Context, name string) (GetAuthDataRow, error) {
	row := q.db.QueryRowContext(ctx, getAuthData, name)
	var i GetAuthDataRow
	err := row.Scan(&i.UserID, &i.Password)
	return i, err
}

const getSalt = `-- name: GetSalt :one
select val from state where key = 'pwsalt'
`

func (q *Queries) GetSalt(ctx context.Context) (string, error) {
	row := q.db.QueryRowContext(ctx, getSalt)
	var val string
	err := row.Scan(&val)
	return val, err
}

const insertSalt = `-- name: InsertSalt :exec
insert into state (key, val) values ('pwsalt', $1)
`

func (q *Queries) InsertSalt(ctx context.Context, salt string) error {
	_, err := q.db.ExecContext(ctx, insertSalt, salt)
	return err
}

const insertSession = `-- name: InsertSession :exec
insert into sessions (userID, token, remote, created) values ($1, $2, $3, $4)
`

type InsertSessionParams struct {
	UserID  int32
	Token   string
	Remote  string
	Created string
}

func (q *Queries) InsertSession(ctx context.Context, arg InsertSessionParams) error {
	_, err := q.db.ExecContext(ctx, insertSession,
		arg.UserID,
		arg.Token,
		arg.Remote,
		arg.Created,
	)
	return err
}

const insertUser = `-- name: InsertUser :exec
insert into users (name, password) values ($1, $2)
`

type InsertUserParams struct {
	Name     string
	Password string
}

func (q *Queries) InsertUser(ctx context.Context, arg InsertUserParams) error {
	_, err := q.db.ExecContext(ctx, insertUser, arg.Name, arg.Password)
	return err
}

const insertWine = `-- name: InsertWine :execresult
insert into wines (name, rating, country) values ($1, $2, $3)
`

type InsertWineParams struct {
	Name    string
	Rating  sql.NullInt32
	Country sql.NullString
}

func (q *Queries) InsertWine(ctx context.Context, arg InsertWineParams) (sql.Result, error) {
	return q.db.ExecContext(ctx, insertWine, arg.Name, arg.Rating, arg.Country)
}

const isValidSession = `-- name: IsValidSession :one

select users.name
from users
join sessions using (userID)
where sessions.token = $1
`

//--
//-- Session and user management
//--
func (q *Queries) IsValidSession(ctx context.Context, token string) (string, error) {
	row := q.db.QueryRowContext(ctx, isValidSession, token)
	var name string
	err := row.Scan(&name)
	return name, err
}

const listComments = `-- name: ListComments :many
select comment_id, wine_id, content from comments where wine_id = $1
`

func (q *Queries) ListComments(ctx context.Context, wineID int32) ([]Comment, error) {
	rows, err := q.db.QueryContext(ctx, listComments, wineID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Comment
	for rows.Next() {
		var i Comment
		if err := rows.Scan(&i.CommentID, &i.WineID, &i.Content); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listSessions = `-- name: ListSessions :many
select users.name as name, sessions.created as created, sessions.remote as remote
from users
join sessions using (userID)
`

type ListSessionsRow struct {
	Name    string
	Created string
	Remote  string
}

func (q *Queries) ListSessions(ctx context.Context) ([]ListSessionsRow, error) {
	rows, err := q.db.QueryContext(ctx, listSessions)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []ListSessionsRow
	for rows.Next() {
		var i ListSessionsRow
		if err := rows.Scan(&i.Name, &i.Created, &i.Remote); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listUsers = `-- name: ListUsers :many
select name from users
`

func (q *Queries) ListUsers(ctx context.Context) ([]string, error) {
	rows, err := q.db.QueryContext(ctx, listUsers)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []string
	for rows.Next() {
		var name string
		if err := rows.Scan(&name); err != nil {
			return nil, err
		}
		items = append(items, name)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listWines = `-- name: ListWines :many
select wine_id, name, rating, country, cast(picture is not null as bool) as has_picture from wines
`

type ListWinesRow struct {
	WineID     int32
	Name       string
	Rating     sql.NullInt32
	Country    sql.NullString
	HasPicture bool
}

func (q *Queries) ListWines(ctx context.Context) ([]ListWinesRow, error) {
	rows, err := q.db.QueryContext(ctx, listWines)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []ListWinesRow
	for rows.Next() {
		var i ListWinesRow
		if err := rows.Scan(
			&i.WineID,
			&i.Name,
			&i.Rating,
			&i.Country,
			&i.HasPicture,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const loadPicture = `-- name: LoadPicture :one

select picture from wines where wine_id = $1
`

//--
//-- Pictures and such
//--
func (q *Queries) LoadPicture(ctx context.Context, wineID int32) ([]byte, error) {
	row := q.db.QueryRowContext(ctx, loadPicture, wineID)
	var picture []byte
	err := row.Scan(&picture)
	return picture, err
}

const loadWine = `-- name: LoadWine :one
select wine_id, name, rating, country, cast(picture is not null as bool) as has_picture
  from wines
 where wine_id = $1
`

type LoadWineRow struct {
	WineID     int32
	Name       string
	Rating     sql.NullInt32
	Country    sql.NullString
	HasPicture bool
}

func (q *Queries) LoadWine(ctx context.Context, wineID int32) (LoadWineRow, error) {
	row := q.db.QueryRowContext(ctx, loadWine, wineID)
	var i LoadWineRow
	err := row.Scan(
		&i.WineID,
		&i.Name,
		&i.Rating,
		&i.Country,
		&i.HasPicture,
	)
	return i, err
}

const storePicture = `-- name: StorePicture :exec
update wines set picture = $1 where wine_id = $2
`

type StorePictureParams struct {
	Picture []byte
	WineID  int32
}

func (q *Queries) StorePicture(ctx context.Context, arg StorePictureParams) error {
	_, err := q.db.ExecContext(ctx, storePicture, arg.Picture, arg.WineID)
	return err
}

const updateUser = `-- name: UpdateUser :execresult
update users set password = $1 where name = $2
`

type UpdateUserParams struct {
	Password string
	Name     string
}

func (q *Queries) UpdateUser(ctx context.Context, arg UpdateUserParams) (sql.Result, error) {
	return q.db.ExecContext(ctx, updateUser, arg.Password, arg.Name)
}

const updateWine = `-- name: UpdateWine :exec
update wines
set
	name = $1,
	rating = $2,
	country = $3
where wine_id = $4
`

type UpdateWineParams struct {
	Name    string
	Rating  sql.NullInt32
	Country sql.NullString
	WineID  int32
}

func (q *Queries) UpdateWine(ctx context.Context, arg UpdateWineParams) error {
	_, err := q.db.ExecContext(ctx, updateWine,
		arg.Name,
		arg.Rating,
		arg.Country,
		arg.WineID,
	)
	return err
}
