{{ template "base" . }}

{{ define "title" }}Index{{ end }}

{{ define "header-left" }}
<div class="left">
	<h1>In Vino Veritas</h1>
	<em>Im Wein ist die Wahrheit</em>
</div>
{{ end }}

{{ define "content" }}
{{ template "header" . }}

<div class="content withfooter pure-u-1">
	<div class="maxwidth box">
		<table class="pure-table">
			<thead><tr>
				<th class="fill">Name</th>
				<th>Rating</th>
				<th>Country</th>
			</tr></thead>
			<tbody>
			{{ range .Wines }}
				<tr>
					<td><a href="/details?id={{ .WineID }}">{{ .Name }}</a></td>
					<td>{{ .Rating.Int32 }}</td>
					<td>{{ if .Country.Valid }}
						<img src="/static/flags/{{ .Country.String }}.png">
						({{ .Country.String }})
					{{ end }}</td>
				</tr>
			{{ end }}
			</tbody>
		</table>
	</div>
</div>

<footer class="pure-u-1">
	<div class="maxwidth box">
		{{ if .User.CanWrite }}
		<form class="pure-form" method="POST" enctype="multipart/form-data" action="/add">
			<fieldset>
				<div class="pure-g">
					<div class="pure-u-3-4">
						<div class="pad-bottom pad-right">
							<input class="name" type="text" name="name" placeholder="Name" required>
						</div>

						<input type="file" name="picture" accept="image/png, image/jpeg">
					</div>

					<div class="pure-u-1-4">
						<div class="pad-bottom">
							<input class="rating" type="number" name="rating" placeholder="Rating">
						</div>
						<div class="centered">
							<button type="submit" class="round pure-button pure-button-primary">
								<i class="fas fa-plus"></i>
							</button>
						</div>
					</div>
				</table>
			</fieldset>
		</form>
		{{ end }}
	</div>
</footer>

{{ end }}